// CETerminal.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "CETerminal.h"
#include <commctrl.h>
#include <commdlg.h>

// Window-Klassen, Fenster-Handles, Titeltext und anderes Zeug
const TCHAR   MY_CLASS[]      = { L"CETERMINAL" };
const TCHAR   MY_TITLE[]      = { L"CE - Terminal" };
const LOGFONT MyLogfont       = {-12, // LONG lfHeight; 
                                   0, // LONG lfWidth; 
                                   0, // LONG lfEscapement; 
                                   0, // LONG lfOrientation; 
                                 400, // LONG lfWeight; 
                                   0, // BYTE lfItalic; 
                                   0, // BYTE lfUnderline; 
                                   0, // BYTE lfStrikeOut; 
                        ANSI_CHARSET, // BYTE lfCharSet; 
                  OUT_DEFAULT_PRECIS, // BYTE lfOutPrecision ; 
                 CLIP_DEFAULT_PRECIS, // BYTE lfClipPrecision ; 
                     DEFAULT_QUALITY, // BYTE lfQuality ; 
                        FIXED_PITCH , // BYTE lfPitchAndFamily ; 
                          L""  // TCHAR lfFaceName[LF_FACESIZE] ; 
                                };


HINSTANCE HMyInstance;        // The current instance
HWND      HMyWnd;             // The current window
HWND      HMyCommandBar;      // The command bar handle
HMENU     HMyMenu;
int       CmdBarHoehe;
UINT      HMyTimer;
int       ZeilenHoehe;
HFONT     HMyFont;
int       CurrentScrollPos;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);



// Terminal-Puffer und Logdatei
// ============================
#define  IDLOG              WM_USER+101
#define  SCREENBUFFERLENGTH 5000
TCHAR    ScreenBuffer[SCREENBUFFERLENGTH];

OPENFILENAME of;
HANDLE HLogFile;
char  LogBuf[512];
int   ZxCount;
DWORD lbz;
BOOL  LOGGING;
TCHAR MyFileName[MAX_PATH] = {0};
TCHAR MyPathName[MAX_PATH] = {L"\\windows"};
TCHAR MyExtName[] = {L"log"};
const char H[17] = {"0123456789ABCDEF"};


void SetupMyNameRecord (BOOL MustExist)
{ long Fl;
  Fl = OFN_CREATEPROMPT | OFN_HIDEREADONLY | OFN_LONGNAMES;
  if (MustExist) Fl = Fl | OFN_FILEMUSTEXIST;
  memset((LPVOID)&of, 0, sizeof(OPENFILENAME));
  of.lStructSize     = sizeof(OPENFILENAME);
  of.hwndOwner       = HMyWnd;
  of.lpstrFile       = MyFileName;
  of.lpstrInitialDir = NULL;
  of.nMaxFile        = sizeof(MyFileName)/sizeof(TCHAR);
  of.lpstrDefExt     = MyExtName;
  of.lpfnHook = NULL;
  of.Flags          |= Fl;
  of.lpstrTitle      = L"Select LogFile";
  of.lpstrFilter     = L"LogFiles(*.log)\0*.log\0All Files (*.*)\0*.*\0\0";
}


BOOL FlushLogBuf (void)
{ DWORD written;
  if (!lbz) return TRUE;
  if (HLogFile==INVALID_HANDLE_VALUE) return FALSE;
  WriteFile(HLogFile,LogBuf,lbz, &written, NULL);
  if (written!=lbz) {  lbz = 0; return FALSE; }
  lbz = 0;
  return TRUE;
}

BOOL CloseLogfile (void)
{ BOOL b;
  b = TRUE;
  LOGGING = FALSE;
  if (HLogFile!=INVALID_HANDLE_VALUE)
  { if (lbz) FlushLogBuf(); 
    b = CloseHandle(HLogFile);
    HLogFile = INVALID_HANDLE_VALUE;
  }
  return b;
}

BOOL OpenLogfile (void)
{ long fsz;
  if (HLogFile!=INVALID_HANDLE_VALUE) CloseLogfile();
  lbz = 0;
  HLogFile = CreateFile (MyFileName, GENERIC_READ | GENERIC_WRITE, 0, NULL,
                         OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
  if (HLogFile==INVALID_HANDLE_VALUE) return FALSE;
  fsz = GetFileSize(HLogFile, NULL);
  if (fsz) SetFilePointer(HLogFile,fsz,NULL,FILE_BEGIN);
  return TRUE;
}


void AppendText (TCHAR* Ptext)
{ register long i, j, k;
  long plen, tlen;

  tlen = wcslen(ScreenBuffer);
  plen = wcslen(Ptext);
  if ((tlen+plen)>=SCREENBUFFERLENGTH)
  { i = 0; j = plen; k = SCREENBUFFERLENGTH - plen;
    while (i<k) ScreenBuffer[i++] = ScreenBuffer[j++];
    ScreenBuffer[i] = 0; 
  }
  wcscat(ScreenBuffer, Ptext);
}




// Schnittstellen-Einrichtung und Baudrate 
#define  COMBOID       WM_USER+200
#define  COMCOMID      WM_USER+201
#define  baudBoxWeite  120
#define  comBoxWeite   80
#define  buffermax     1024

const TCHAR MY_COM1[]  = { L"COM1:" };
const TCHAR MY_COM2[]  = { L"COM2:" };
const TCHAR MY_COM3[]  = { L"COM3:" };
const TCHAR MY_COM4[]  = { L"COM4:" };

const DWORD Baudraten[17] = {75, 110, 150, 300, 600, 1200, 1800, 
                             2400, 4800, 7200, 9600, 14400, 19200,
                             38400, 56000, 57600, 115200 };

HWND     HMyBaudBox;
HWND     HMyComBox;
HANDLE   hCOMPort;
COMSTAT  statPort;
DWORD    dwErrorCode;
TCHAR    Portname[16];
long     MyBaudrate;
byte     RxBuff[buffermax+8];
int      inPtr, outPtr;
BOOL     localEcho;
BOOL     doFilter;
BOOL     doHexDump;


BOOL OpenTheSerialPort (void)
{ DCB dcbPort;                        //device control block   
  AppendText(L"\nffne ");
  AppendText(Portname);
  hCOMPort = CreateFile (Portname,     // Pointer to the name of the port
                         GENERIC_READ | GENERIC_WRITE, 
                         0,            // Share mode
                         NULL,         // Pointer to the security attribute
                         OPEN_EXISTING,// How to open the serial port
                         0,            // not overlapped
                         NULL);        // Handle to port with attribute
                                      
  if (hCOMPort==INVALID_HANDLE_VALUE)
  { AppendText(L" ...Fehler!\r");
    localEcho = TRUE;
    return FALSE;
  }
                  // set the baud rate and other parameters 
  if (GetCommState(hCOMPort, &dcbPort))
  {               // fill in the fields of the structure 
     dcbPort.BaudRate        = MyBaudrate;
     dcbPort.ByteSize        = 8;
     dcbPort.Parity          = NOPARITY;
     dcbPort.StopBits        = ONESTOPBIT;
     dcbPort.fOutxCtsFlow    = 0;   // kein CTS beim Senden beachten
     dcbPort.fOutxDsrFlow    = 0;   // kein DSR beim Senden beachten
     dcbPort.fDtrControl     = DTR_CONTROL_DISABLE;
     dcbPort.fDsrSensitivity = 0;   // DSR beim Empfang nicht beachten
     dcbPort.fAbortOnError   = 0;   // weitermachen wenn Fehler gewesen
     if (SetCommState(hCOMPort, &dcbPort)) AppendText(L" 8N1\rPort geffnet.\r");    
  }
  memset(&RxBuff, 0, sizeof(RxBuff));
  inPtr = outPtr = 0;
  localEcho = FALSE;
  return TRUE;
}


BOOL CloseTheSerialPort (void)
{ HANDLE h;
  if (hCOMPort!=INVALID_HANDLE_VALUE)
    { h = hCOMPort;
      hCOMPort = INVALID_HANDLE_VALUE;
      return CloseHandle(h); 
    }
  return TRUE;
}


// Lesen und Schreiben am COM-Port

DWORD ComPortWrite (char* sData)
{ DWORD dwCharsWritten;
  DWORD dwCharsToWrite;
  char* Pt;

  if (hCOMPort == INVALID_HANDLE_VALUE) return 0;
  dwCharsToWrite =
  dwCharsWritten = 0;
  Pt = sData;
  while (*Pt++) ++dwCharsToWrite;
  if (!WriteFile(hCOMPort, sData, dwCharsToWrite, &dwCharsWritten, NULL)) return 0;
  return dwCharsWritten;
}

 
long ComPortGetInCount (void)    //Return the number of bytes waiting in the queue 
{ long i;
  dwErrorCode = i = 0;
  if (hCOMPort==INVALID_HANDLE_VALUE) return 0;
  if (!ClearCommError(hCOMPort, &dwErrorCode, &statPort)) return 0;
  if (dwErrorCode) return 0;
  i = statPort.cbInQue;
  return i;     
}


TCHAR ComPortRead (void)
{ DWORD Ch_Cnt;
  DWORD Ch_Read;


  if (inPtr > outPtr)               // Puffer ist nicht leer, also daraus lesen
   return RxBuff[outPtr++];

  if (hCOMPort == INVALID_HANDLE_VALUE) return 0xFFFF;

  inPtr = outPtr = 0;               // Puffer ist leer, also Windows bemhen...
  Ch_Cnt = ComPortGetInCount();
  if (!Ch_Cnt) return 0xFFFF;       // wenn nix vorhanden, Ende 
  if (Ch_Cnt >= buffermax) Ch_Cnt = buffermax-1;

  if (!ReadFile(hCOMPort, RxBuff, Ch_Cnt, &Ch_Read, NULL)) return 0xFFFF;
  inPtr  = Ch_Read;
  outPtr = 0;
  if (inPtr > 0) return RxBuff[outPtr++];
  return 0xFFFF;
}


                  
void ComPortFlush (void) // Flush the port by reading any characters in the queue 
{ inPtr  = 0;
  outPtr = 0;
  if (hCOMPort!=INVALID_HANDLE_VALUE)
    PurgeComm(hCOMPort, PURGE_TXABORT | PURGE_RXABORT |
                        PURGE_TXCLEAR | PURGE_RXCLEAR);
}






// allgemeine Verwaltung der Darstellung auf dem Display
// ========================================================================

void Aktualisiere_Commandbar (HWND  hWnd)
{ int i;
  TCHAR St[24];
  RECT R;
  long L;
  long cbh, menuw, ornatew, baudw, comw;

  cbh     = CmdBarHoehe;
  if (cbh<18) cbh = 18;
  menuw   = cbh * 8;
  ornatew = cbh * 3;
  baudw   = baudBoxWeite;
  comw    = comBoxWeite;

  if (HMyCommandBar) { CommandBar_Destroy(HMyCommandBar);
                       HMyCommandBar = NULL;
                     }
  HMyCommandBar = CommandBar_Create(HMyInstance, hWnd, 1);			
  CommandBar_InsertMenubar(HMyCommandBar,  HMyInstance, IDM_MENU, 0);
  HMyMenu = CommandBar_GetMenu(HMyCommandBar,0); 

  GetClientRect(hWnd, &R);
  L = R.right - menuw - ornatew - 6;
  if (L < (baudw + comw))
  { L = L * 128;
    L = L / (baudw + comw);
	baudw = baudw * L;
	comw  = comw * L;
	baudw = baudw / 128;
	comw  = comw / 128;
  }


  HMyBaudBox = CommandBar_InsertComboBox(HMyCommandBar, 
                                         HMyInstance, 
                                         baudw, 
                                         CBS_DROPDOWNLIST | WS_VSCROLL,
                                         COMBOID, 
                                         1); 
  i = 0;
  while (i<17)
  { swprintf(St,L"%d Baud", Baudraten[i]);
    SendMessage(HMyBaudBox, CB_ADDSTRING, 0, (long) St);
    ++i;
  }
  SendMessage(HMyBaudBox, CB_SETCURSEL, 10, 0);


  HMyComBox = CommandBar_InsertComboBox(HMyCommandBar, 
                                        HMyInstance, 
                                        comw, 
                                        CBS_DROPDOWNLIST | WS_VSCROLL,
                                        COMCOMID, 
                                        2); 
  SendMessage(HMyComBox, CB_ADDSTRING, 0, (long) MY_COM1);
  SendMessage(HMyComBox, CB_ADDSTRING, 0, (long) MY_COM2);
  SendMessage(HMyComBox, CB_ADDSTRING, 0, (long) MY_COM3);
  SendMessage(HMyComBox, CB_ADDSTRING, 0, (long) MY_COM4);
  SendMessage(HMyComBox, CB_SETCURSEL, 0, 0);

  CommandBar_AddAdornments(HMyCommandBar, WM_HELP, 0);
  SetScrollRange(hWnd, SB_VERT, 5, 200, FALSE);
  CurrentScrollPos = 199;
  SetScrollPos(hWnd, SB_VERT, 200, TRUE);
}


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{	MSG msg;
	HACCEL hAccelTable;

	if (!InitInstance (hInstance, nCmdShow)) return FALSE;
    InitCommonControls();
    hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CETERMINAL);

	while (GetMessage(&msg, NULL, 0, 0)) 
    { if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{	TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}



ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MYICON));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= MY_CLASS;  //szWindowClass;

	return RegisterClass(&wc);
}


// alte Styles: fhrten zu sizeable und Caption, was Platzverschwendung war.
//#define MY_STYLE (WS_VISIBLE | WS_SIZEBOX | WS_VSCROLL | WS_OVERLAPPED)
//#define MY_EXSTYLE   WS_EX_CLIENTEDGE

#define MY_STYLE (WS_VISIBLE |  WS_VSCROLL )
#define MY_EXSTYLE   0

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{ int i;

  i = SCREENBUFFERLENGTH;
  while (i) ScreenBuffer[--i] = 0;

  HLogFile   = NULL;
  MyBaudrate = 9600;
  LOGGING    = FALSE;
  hCOMPort   = INVALID_HANDLE_VALUE;
  HLogFile   = INVALID_HANDLE_VALUE;
  localEcho  =
  doFilter   =
  doHexDump  = FALSE;

  wcscpy (Portname, L"COM1:");
  ZeilenHoehe = 12;
  ZxCount = 0;
  CurrentScrollPos = 199;

  HMyInstance = hInstance;                // Store instance handle in our global variable
  MyRegisterClass(hInstance, (LPTSTR) &MY_CLASS);
  HMyWnd = CreateWindowEx (MY_EXSTYLE,      // DWORD ExStyle
                           MY_CLASS,        // LPCTSTR Klassenname
                           MY_TITLE,        // LPCTSTR WindowName
                           MY_STYLE,        // DWORD   Style
                           CW_USEDEFAULT,   // X
                           CW_USEDEFAULT,   // Y
                           CW_USEDEFAULT,   // Breite
                           CW_USEDEFAULT,   // Hhe
                           NULL,            // HWND Parent
                           NULL,            // HMENU Menue
                           hInstance,       // HANDLE Instance
                           NULL);           // PVOID lpParam

  if (!HMyWnd)  return FALSE;

  HMyFont = CreateFontIndirect(&MyLogfont); 
  ShowWindow(HMyWnd, nCmdShow);   // legt fest, wie das Fenster darzustellen ist
  UpdateWindow(HMyWnd);           // sendet direkt WM_PAINT an die WndProc
  CmdBarHoehe = 0;
  if (HMyCommandBar)
  {  CommandBar_Show(HMyCommandBar, TRUE);
     CmdBarHoehe = CommandBar_Height(HMyCommandBar);
  }
  HMyTimer = SetTimer(HMyWnd, WM_TIMER, 36, NULL);
  return TRUE;
}





LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{	HDC hdc;
	int i, wmId, wmEvent;
	PAINTSTRUCT ps;
    RECT rt, zrt;
    TEXTMETRIC tm;
    int chcount;
    TCHAR* Pt;
    long Index;
    TCHAR aText[130];
    TCHAR Ch,MaxCh;    

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
            {   case ID_NEWLOGFILE:
                   SetupMyNameRecord(1);
                   if (GetSaveFileName(&of)) 
                   { OpenLogfile();
                     AppendText(L"\r\nNew Logfile = ");
                     AppendText(MyFileName);
                     GetClientRect(hWnd, &rt);
                     InvalidateRect(hWnd,&rt,TRUE);

                   }
                   break;
                case ID_OPENLOGFILE:
                   SetupMyNameRecord(1);
                   if (GetSaveFileName(&of)) 
                   { AppendText(L"\r\nOpen Logfile = ");
                     AppendText(MyFileName);
                     GetClientRect(hWnd, &rt);
                     InvalidateRect(hWnd,&rt,TRUE);

                   }
                   break;
                case ID_LOCALECHO:
                   if (localEcho)
                   { localEcho = FALSE;
                     CheckMenuItem(HMyMenu, ID_LOCALECHO, MF_UNCHECKED);
                   }
                   else
                   { localEcho = TRUE;
                     CheckMenuItem(HMyMenu, ID_LOCALECHO, MF_CHECKED);                     
                   }
                   break;
                case ID_FILTER:
                   if (doFilter)
                   { doFilter = FALSE;
                     CheckMenuItem(HMyMenu, ID_FILTER, MF_UNCHECKED);
                   }
                   else
                   { doFilter = TRUE;
                     CheckMenuItem(HMyMenu, ID_FILTER, MF_CHECKED);
                   }
                   break;
                case ID_HEXDUMP:
                   if (doHexDump)
                   { doHexDump = FALSE;
                     CheckMenuItem(HMyMenu, ID_HEXDUMP, MF_UNCHECKED);
                   }
                   else
                   { doHexDump = TRUE;
                     CheckMenuItem(HMyMenu, ID_HEXDUMP, MF_CHECKED);
                   }
                   break;
                case ID_CLOSELOGFILE:
                   CloseLogfile();
                   break;
				case IDM_HELP_ABOUT:
				   DialogBox(HMyInstance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_FILE_EXIT:
				   DestroyWindow(hWnd);
				   break;
                case COMBOID:
                   aText[0] = 0;
                   switch (wmEvent)
                   { case CBN_SELENDOK:
                          Index = SendMessage(HMyBaudBox, CB_GETCURSEL, 0, 0);
                          if (Index<0) break;
                          chcount = SendMessage(HMyBaudBox, CB_GETLBTEXTLEN, Index, 0);
                          if (chcount > 14) break;
                          SendMessage (HMyBaudBox, CB_GETLBTEXT, Index, (long) &aText);
                          AppendText(L"\r\n");
                          AppendText(aText);
                          MyBaudrate = Baudraten[Index];
                          CloseTheSerialPort();
                          OpenTheSerialPort(); 
                          GetClientRect(hWnd, &rt);
                          InvalidateRect(hWnd,&rt,TRUE);
                          SetFocus(hWnd);
                   }
                   break;
                case COMCOMID:
                   aText[0] = 0;
                   switch (wmEvent)
                   { case CBN_SELENDOK:
                          Index = SendMessage(HMyComBox, CB_GETCURSEL, 0, 0);
                          if (Index<0) break;
                          chcount = SendMessage(HMyComBox, CB_GETLBTEXTLEN, Index, 0);
                          if (chcount > 15) break;
                          SendMessage (HMyComBox, CB_GETLBTEXT, Index, (long) &Portname);
                          CloseTheSerialPort();
                          OpenTheSerialPort(); 
                          GetClientRect(hWnd, &rt);
                          InvalidateRect(hWnd,&rt,TRUE);
                          SetFocus(hWnd);
                   }
                   break;
                case ID_LOG:
                   if (!HLogFile)
                    { LOGGING = FALSE;
                      AppendText(L"\r\nEs ist keine Logdatei ausgewhlt!\r\n");
                    }
                   else 
                    { AppendText(L"\r\nLog nach ");
                      AppendText(MyFileName);
                      AppendText(L" ist aktiviert.\r\n");
                      LOGGING = TRUE;
                    }
                   GetClientRect(hWnd, &rt);
                   InvalidateRect(hWnd,&rt,TRUE);
                   break;
                case ID_NOLOG:
                   LOGGING = FALSE;
                   break;
			}
			break;

        case WM_CREATE:
		    Aktualisiere_Commandbar(hWnd);
            if (!OpenTheSerialPort())
            MessageBox(HMyWnd,L"Kann COM Port nicht ffnen", 
                              L"COM Port Fehler", 
                              MB_OK | MB_ICONWARNING);
            localEcho  =
            doFilter   =
            doHexDump  = FALSE;
			break;

        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);   // Device-Context einholen
            SelectObject(hdc, HMyFont);    // den Display-Font festlegen
            GetClientRect(hWnd, &rt);      // Nutzbereich einholen
            GetTextMetrics(hdc, &tm);      // Daten zum Font einholen
            ZeilenHoehe = tm.tmHeight;
            zrt = rt;
            zrt.top = zrt.bottom - tm.tmHeight;
            Pt = ScreenBuffer;
            while (*Pt) ++Pt;  // Pt zeigt hinter den Text
            --Pt;              // Pt zeigt jetzt auf letztes Zeichen

            i = 199 - CurrentScrollPos;
            // vorrcken, bis i Zeilen bergangen sind
            while (i>0)
            { while ((Pt>ScreenBuffer) && (*Pt >= ' ')) --Pt;
              if (Pt>ScreenBuffer) --Pt;
              --i;
            }
            // von unten nach oben die letzten Zeilen ausgeben,
            // bis der Bildschirm voll oder alles dargestellt ist 
          nochmal:
            chcount = 0;
            while ((Pt >= ScreenBuffer) && (*Pt >= ' ') && (*Pt != (256+13)))
            { --Pt; ++chcount; }
            ++Pt;
            DrawText(hdc, Pt, chcount, &zrt, DT_SINGLELINE | DT_VCENTER | DT_LEFT);
            zrt.bottom = zrt.top;
            zrt.top = zrt.top - tm.tmHeight;
            --Pt;
            if ((Pt > ScreenBuffer) && ((*Pt < ' ')||(*Pt == (256+13)))) --Pt;  // CR, LF usw. bergehen
            if (zrt.top >= CmdBarHoehe) goto nochmal;

            EndPaint(hWnd, &ps);
            break;

  	     case WM_DESTROY:
            CloseTheSerialPort();
            CloseLogfile();
			CommandBar_Destroy(HMyCommandBar);
            DeleteObject(HMyFont);
			PostQuitMessage(0);
			break;

        case WM_SIZE:               
            Aktualisiere_Commandbar(hWnd);
            break;

        case WM_VSCROLL:
             switch ((int)LOWORD(wParam))
             { case SB_THUMBPOSITION:
               case SB_THUMBTRACK:
                   CurrentScrollPos = (short int)HIWORD(wParam);
                   break;
               case SB_LINEUP: 
                   --CurrentScrollPos;
                   break;
               case SB_LINEDOWN: 
                   ++CurrentScrollPos;
                   break;
               case SB_PAGEUP: 
                   CurrentScrollPos = CurrentScrollPos - 8;
                   break;
               case SB_PAGEDOWN: 
                   CurrentScrollPos = CurrentScrollPos + 8;
                   break;
             }
             if (CurrentScrollPos < 0) CurrentScrollPos = 0;
             if (CurrentScrollPos > 199) CurrentScrollPos = 199;
             SetScrollPos(hWnd, SB_VERT, CurrentScrollPos, TRUE);
             GetClientRect(hWnd, &rt);
             InvalidateRect(hWnd,&rt,TRUE);
             SetFocus(hWnd);
             break;

        case WM_KEYDOWN:
             i = 0;
             switch (wParam)
             { case  0x23: CurrentScrollPos = 199;   // End
                           i = 1; 
                           break;
               case  0x24: CurrentScrollPos = 0;     // Home
                           i = 1; 
                           break;
               case  0x25: break;                    // Cursor links
               case  0x26: { i = 1;                  // Cursor aufwrts
                             if (lParam & (1<<29)) i = 10;
                             CurrentScrollPos -= i; 
                             if (CurrentScrollPos < 0)
                                   CurrentScrollPos = 0;
                           }
                           break;
               case  0x27: break;                    // Cursor rechts
               case  0x28: { i = 1;                  // Cursor abwrts
                             if (lParam & (1<<29)) i = 10;
                             CurrentScrollPos += i; 
                             if (CurrentScrollPos > 199)
                                   CurrentScrollPos = 199;
                           }
                           break;
             }
             if (i)
             { SetScrollPos(hWnd, SB_VERT, CurrentScrollPos, TRUE);
               GetClientRect(hWnd, &rt);
               InvalidateRect(hWnd,&rt,TRUE);
               SetFocus(hWnd);
             }
             break;

        case WM_CHAR:
            if (wParam == 10) break;
            aText[0] = wParam;
            aText[1] = 0;
            ComPortWrite ((char*) &aText[0]);
            if (localEcho) RxBuff[inPtr++] = wParam & 0xFF;
            break;

        case WM_TIMER:
            Index   = 0;
            chcount = 0;
            MaxCh = 252;
            if (doFilter) MaxCh = 124;
            Ch = ComPortRead();
            if (Ch!=0xFFFF) Index = 1;
            while (Ch!=0xFFFF)
              { if (doHexDump)
                 { aText[chcount++] = H[(Ch >> 4) & 15];
                   aText[chcount++] = H[Ch & 15];
                   aText[chcount++] = ' ';
                   aText[chcount] = 0;
                   ZxCount += 3;
                 }
                else
                 { if (LOGGING) 
                   { if (lbz > 511) FlushLogBuf(); 
                     LogBuf[lbz] = Ch & 0xFF;
                     ++lbz;
                   }  

                   if (Ch >= ' ')
                   { if (Ch > MaxCh) Ch = '.'; // weggefilterte Zeichen-->Punkt
                     aText[chcount++] = Ch;
                     aText[chcount] = 0;
                     ++ZxCount;
                   }
                   else 
                   if (Ch==13)
                     { aText[chcount++] = Ch;
                       aText[chcount] = 0;
                       ZxCount = 0;
                       ++Index;
                     }                   
                 }                

                if (chcount > 128)      // der Puffer ist 130 Zeichen gro!
                  { AppendText(aText);
                    chcount = 0;
                    aText[0] = 0;
                  }

                if (ZxCount > 81)
                { aText[chcount++] = 256+13;
                  aText[chcount] = 0;
                  ZxCount = 0;
                  ++Index;
                }

                Ch = ComPortRead();
              } 

            aText[chcount] = 0;
            if (chcount) AppendText(aText); 
            if (Index)
            { GetClientRect(hWnd, &rt);
              if (Index<2) rt.top = rt.bottom - ZeilenHoehe;
              InvalidateRect(hWnd,&rt,TRUE);
            }
            break;

        default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}



// Message handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
